<template>
  <div class="input" :class="{ 'input--error': isError }">
    <!--suppress HtmlFormInputWithoutLabel -->
    <input class="input__field"
           :class="{ active : val.length > 0 }"
           :id="name"
           :type="type"
           :name="name"
           :autocomplete="autocomplete"
           v-model.trim="val">
    <label class="input__label" :for="name">
      <span>{{name}}</span>
    </label>
    <div class="input__optional">
      <slot name="optional"></slot>
    </div>
    <div class="input__error">
      <slot name='error'></slot>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    value: [String, Number, Date],
    name: String,
    type: String,
    isError: {
      type: Boolean,
      default: false
    },
    autocomplete: {
      type: String,
      default: 'on'
    }
  },
  data() {
    return {
      val: this.value
    }
  },
  watch: {
    val() {
      this.$emit('change', this.val);
    },
    value() {
      this.val = this.value;
    }
  }
}
</script>

<style lang="sass" scoped>
/* Change autocomplete styles in WebKit */
input:-webkit-autofill,
input:-webkit-autofill:hover,
input:-webkit-autofill:focus
  border-bottom: rem(1) solid #e0e0e0
  transition: background-color 5000s ease-in-out 0s
  -webkit-text-fill-color: $textColorMain
  caret-color: $textColorMain
.input
  position: relative
  min-width: rem(220)
  &__field
    position: relative
    display: block
    border-radius: 0.375rem
    border: 0.063rem solid #e0e0e0
    background-color: #ffffff
    width: 100%
    padding: rem(10) rem(16)
    color: $textColorMain
    font-family: $mainFont
    font-size: 1rem
    font-weight: 400
    line-height: 1.5
    &:focus, &.active
      + .input__label
        span
          color: #636e7e
          transform: translate3d(-16px, -150%, 0) scale(0.875)
  &__label
    position: absolute
    pointer-events: none
    width: auto
    left: rem(16)
    bottom: rem(10)
    text-align: left
    span
      display: block
      color: $textColorMain
      font-family: $mainFont
      font-size: 1rem
      font-weight: 400
      line-height: 1.5
      transition: transform 0.3s
      transform-origin: left
  &__error
    position: absolute
    bottom: 0
    transform: translateY(100%)
    display: none
    .error
      font-family: $mainFont
      font-size: rem(12)
      line-height: 1.25
      color: $colorMain
      text-align: left
  &__optional
    position: absolute
    top: 50%
    right: 0
    transform: translateY(-50%)
  &--error
    animation-name: shakeError
    animation-fill-mode: forwards
    animation-duration: .6s
    animation-timing-function: ease-in-out
    .input
      &__error
        display: block
</style>
